/////////////////////////////////////////////////////////////////////////////
///  Unit MediaInfoDLLmod                                                 ///
///  Modifikation der MediaInfoDLL aus dem Sourceforge Profekt MediaInfo  ///
/////////////////////////////////////////////////////////////////////////////
///  Original:                                                            ///
///  Quelle : http://cvs.sourceforge.net/viewcvs.py/MediaInfoLib/         ///
///           Project/Delphi/Example                                      ///
///  Author : zenitram                                                    ///
/////////////////////////////////////////////////////////////////////////////
///  Beschreibung:                                                        ///
///  Die Unit beinhaltet die Übersetzungen zur Kommunikation von Delphi   ///
///  mit der in C/C++ geschriebenen MediaInfo.DLL.                        ///
/////////////////////////////////////////////////////////////////////////////
///  Modifikationen von Fr_An:                                            ///
///  Das Original lädt die DLL statisch, die Mod dynamisch.              ///
///////////////////////////////////////////////////////////////////////////
unit MediaInfoDll;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  Windows;
  //Wintypes, WinProcs;

const
  szNameDLL                            = 'MediaInfo.DLL';
  szNameMediaInfoA_Open                = 'MediaInfoA_Open';
  szNameMediaInfoA_Close               = 'MediaInfoA_Close';
  szNameMediaInfoA_Inform              = 'MediaInfoA_Inform';
  szNameMediaInfoA_GetI                = 'MediaInfoA_GetI';
  szNameMediaInfoA_Get                 = 'MediaInfoA_Get';
  szNameMediaInfoA_Open_Buffer         = 'MediaInfoA_Open_Buffer';
  szNameMediaInfoA_Count_Get           = 'MediaInfoA_Count_Get';
  szNameMediaInfoA_SetI                = 'MediaInfoA_SetI';
  szNameMediaInfoA_Set                 = 'MediaInfoA_Set';
  szNameMediaInfoA_Save                = 'MediaInfoA_Save';
  szNameMediaInfoA_Option              = 'MediaInfoA_Option';
  szNameMediaInfoA_State_Get           = 'MediaInfoA_State_Get';
  szNameMediaInfoA_New                 = 'MediaInfoA_New';
  szNameMediaInfoA_Delete              = 'MediaInfoA_Delete';
  szNameMediaInfoA_New_Quick           = 'MediaInfoA_New_Quick';

  szNameMediaInfo_Info_Version         = 'MediaInfo_Info_Version';

  szNameMediaInfo_Open                 = 'MediaInfo_Open';
  szNameMediaInfo_Open_Buffer          = 'MediaInfo_Open_Buffer';
  szNameMediaInfo_Save                 = 'MediaInfo_Save';
  szNameMediaInfo_Close                = 'MediaInfo_Close';
  szNameMediaInfo_Inform               = 'MediaInfo_Inform';
  szNameMediaInfo_GetI                 = 'MediaInfo_GetI';
  szNameMediaInfo_Get                  = 'MediaInfo_Get';
  szNameMediaInfo_SetI                 = 'MediaInfo_SetI';
  szNameMediaInfo_Set                  = 'MediaInfo_Set';
  szNameMediaInfo_Option               = 'MediaInfo_Option';
  szNameMediaInfo_State_Get            = 'MediaInfo_State_Get';
  szNameMediaInfo_Count_Get            = 'MediaInfo_Count_Get';
  szNameMediaInfo_New                  = 'MediaInfo_New';
  szNameMediaInfo_Delete               = 'MediaInfo_Delete';
  szNameMediaInfo_New_Quick            = 'MediaInfo_New_Quick';

  szNameMediaInfoListA_New             = 'MediaInfoListA_New';
  szNameMediaInfoListA_New_Quick       = 'MediaInfoListA_New_Quick';
  szNameMediaInfoListA_Delete          = 'MediaInfoListA_Delete';
  szNameMediaInfoListA_Open            = 'MediaInfoListA_Open';
  szNameMediaInfoListA_Open_Buffer     = 'MediaInfoListA_Open_Buffer';
  szNameMediaInfoListA_Save            = 'MediaInfoListA_Save';
  szNameMediaInfoListA_Close           = 'MediaInfoListA_Close';
  szNameMediaInfoListA_Inform          = 'MediaInfoListA_Inform';
  szNameMediaInfoListA_GetI            = 'MediaInfoListA_GetI';
  szNameMediaInfoListA_Get             = 'MediaInfoListA_Get';
  szNameMediaInfoListA_SetI            = 'MediaInfoListA_SetI';
  szNameMediaInfoListA_Set             = 'MediaInfoListA_Set';
  szNameMediaInfoListA_Option          = 'MediaInfoListA_Option';
  szNameMediaInfoListA_State_Get       = 'MediaInfoListA_State_Get';
  szNameMediaInfoListA_Count_Get       = 'MediaInfoListA_Count_Get';
  szNameMediaInfoListA_Count_Get_Files = 'MediaInfoListA_Count_Get_Files';

  szNameMediaInfoList_New              = 'MediaInfoList_New';
  szNameMediaInfoList_New_Quick        = 'MediaInfoList_New_Quick';
  szNameMediaInfoList_Delete           = 'MediaInfoList_Delete';
  szNameMediaInfoList_Open             = 'MediaInfoList_Open';
  szNameMediaInfoList_Open_Buffer      = 'MediaInfoList_Open_Buffer';
  szNameMediaInfoList_Save             = 'MediaInfoList_Save';
  szNameMediaInfoList_Close            = 'MediaInfoList_Close';
  szNameMediaInfoList_Inform           = 'MediaInfoList_Inform';
  szNameMediaInfoList_GetI             = 'MediaInfoList_GetI';
  szNameMediaInfoList_Get              = 'MediaInfoList_Get';
  szNameMediaInfoList_SetI             = 'MediaInfoList_SetI';
  szNameMediaInfoList_Set              = 'MediaInfoList_Set';
  szNameMediaInfoList_Option           = 'MediaInfoList_Option';
  szNameMediaInfoList_State_Get        = 'MediaInfoList_State_Get';
  szNameMediaInfoList_Count_Get        = 'MediaInfoList_Count_Get';
  szNameMediaInfoList_Count_Get_Files  = 'MediaInfoList_Count_Get_Files';

type
  MediaInfo_stream_t = (
    MediaInfo_Stream_General,
    MediaInfo_Stream_Video,
    MediaInfo_Stream_Audio,
    MediaInfo_Stream_Text,
    MediaInfo_Stream_Chapters,
    MediaInfo_Stream_Image,
    MediaInfo_Stream_Max  );

  MediaInfo_info_t = (
    MediaInfo_Info_Name,
    MediaInfo_Info_Text,
    MediaInfo_Info_Measure,
    MediaInfo_Info_Options,
    MediaInfo_Info_Name_Text,
    MediaInfo_Info_Measure_Text,
    MediaInfo_Info_Info,
    MediaInfo_Info_HowTo,
    MediaInfo_Info_Max  );

  MediaInfo_infooptions_t = (
    MediaInfo_InfoOption_ShowInInform,
    MediaInfo_InfoOption_Support,
    MediaInfo_InfoOption_ShowInSupported,
    MediaInfo_InfoOption_TypeOfValue,
    MediaInfo_InfoOption_Max  );

  MediaInfo_informoptions_t = (
    MediaInfo_InformOption_Nothing,
    MediaInfo_InformOption_Custom,
    MediaInfo_InformOption_HTML,
    MediaInfo_InformOption_Max  );

  MediaInfo_fileoptions_t = (
    MediaInfo_FileOption_Nothing,
    MediaInfo_FileOption_Recursive,
    MediaInfo_FileOption_Close,
    MediaInfo_FileOption_Max  );

  TFNMediaInfoA_New = function
    :Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_New_Quick = function
    (File__: PChar; Options: PChar)
    :Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_Open = function
    (Handle: Cardinal; File__: PChar)
    : Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_Open_Buffer = function
    (Handle: Cardinal;
     Begin_: PByte;
     Begin_Size: Word;
     End_: PByte;
     End_Size: Word)
    : Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};     // Handle
  TFNMediaInfoA_Save = function
    (Handle: Cardinal)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_Close = procedure
    (Handle: Cardinal) cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_Delete = procedure
    (Handle: Cardinal) cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_Inform = function
    (Handle: Cardinal;
     Options: Integer)
    : PChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_GetI = function
    (Handle: Cardinal;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: Integer;
     KindOfInfo: Integer)
    : PChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_Get = function
    (Handle: Cardinal;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: PChar;
     KindOfInfo: Integer;
     KindOfSearch: Integer)
    : PChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_SetI = function
    (Handle: Cardinal;
     ToSet: PChar;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: Word;
     OldParameter: PChar)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_Set = function
    (Handle: Cardinal;
     ToSet: PChar;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: PChar;
     OldParameter: PChar)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_Option = function
    (Handle: Cardinal;
     Option: PChar;
     Value: PChar)
    : PWideChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_State_Get = function
    (Handle: Cardinal)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoA_Count_Get = function
    (Handle: Cardinal;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  TFNMediaInfo_Info_Version = function
    : PChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  TFNMediaInfo_New = function
    :Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_New_Quick = function
    (File__: PWideChar; Options: PWideChar)
    : Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_Open = function
    (Handle: Cardinal; File__: PWideChar)
    : Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_Open_Buffer = function
    (Handle: Cardinal;
     Begin_: PByte;
     Begin_Size: Word;
     End_: PByte;
     End_Size: Word)
    : Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};     // Handle
  TFNMediaInfo_Save = function
    (Handle: Cardinal)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_Close = procedure
    (Handle: Cardinal) cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_Delete = procedure
    (Handle: Cardinal) cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_Inform = function
    (Handle: Cardinal;
     Options: Integer)
    : PWideChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_GetI = function
    (Handle: Cardinal;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: Integer;
     KindOfInfo: Integer)
    : PWideChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_Get = function
    (Handle: Cardinal;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: PWideChar;
     KindOfInfo: Integer;
     KindOfSearch: Integer)
    : PWideChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_SetI = function
    (Handle: Cardinal;
     ToSet: PWideChar;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: Word;
     OldParameter: PWideChar)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_Set = function
    (Handle: Cardinal;
     ToSet: PWideChar;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: PWideChar;
     OldParameter: PWideChar)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_Option = function
    (Handle: Cardinal;
     Option: PWideChar;
     Value: PWideChar)
    : PWideChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_State_Get = function
    (Handle: Cardinal)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfo_Count_Get = function
    (Handle: Cardinal;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  TFNMediaInfoList_New = function
    : Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_New_Quick = function
    (Files_: PWideChar;
     Config: PWideChar)
    : Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_Delete = function
    (Handle: Cardinal)
    : Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_Open =  function
    (Handle: Cardinal;
     Files_: PWideChar;
     Options: Integer)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_Open_Buffer = function
    (Handle: Cardinal;
     Begin_: PByte;
     Begin_Size: Word;
     End_: PByte;
     End_Size: Word)
    : Cardinal cdecl  {$IFDEF WIN32} stdcall {$ENDIF};     // Handle
  TFNMediaInfoList_Save =  function
    (Handle: Cardinal;
     FilePos: Word)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_Close = function
    (Handle: Cardinal;
     FilePos: Word)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_Inform = function
    (Handle: Cardinal;
     FilePos: Word;
     Options: Integer)
    : WideChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_GetI = function
    (Handle: Cardinal;
     FilePos: Word;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: Word;
     InfoKind: Integer)
    : WideChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_Get = function
    (Handle: Cardinal;
     FilePos: Word;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: PWideChar;
     InfoKind: Integer;                                    //MEDIAINFO_INFO_C;
     SearchKind: Integer)                                  //MEDIAINFO_INFO_C)
    : WideChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_SetI = function
    (Handle: Cardinal;
     ToSet: PWideChar;
     FilePos: Word;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: Word;
     OldParameter: PWideChar)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_Set = function
    (Handle: Cardinal;
     ToSet: PWideChar;
     FilePos: Word;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer;
     Parameter: PWideChar;
     OldParameter: PWideChar)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_Option = function
    (Handle: Cardinal;
     Option: PWideChar;
     Value: PWideChar)
    : WideChar cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_State_Get = function
    (Handle: Cardinal)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
  TFNMediaInfoList_Count_Get = function
    (Handle: Cardinal;
     FilePos: Word;
     StreamKind: Integer;                                  //MEDIAINFO_STREAM_C;
     StreamNumber: Integer)
    : Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

var
  MediaInfoA_New            : TFNMediaInfoA_New;
  MediaInfoA_New_Quick      : TFNMediaInfoA_New_Quick;
  MediaInfoA_Open           : TFNMediaInfoA_Open;
  MediaInfoA_Open_Buffer    : TFNMediaInfoA_Open_Buffer;
  MediaInfoA_Save           : TFNMediaInfoA_Save;
  MediaInfoA_Close          : TFNMediaInfoA_Close;
  MediaInfoA_Delete         : TFNMediaInfoA_Delete;
  MediaInfoA_Inform         : TFNMediaInfoA_Inform;
  MediaInfoA_GetI           : TFNMediaInfoA_GetI;
  MediaInfoA_Get            : TFNMediaInfoA_Get;
  MediaInfoA_SetI           : TFNMediaInfoA_SetI;
  MediaInfoA_Set            : TFNMediaInfoA_Set;
  MediaInfoA_Option         : TFNMediaInfoA_Option;
  MediaInfoA_State_Get      : TFNMediaInfoA_State_Get;
  MediaInfoA_Count_Get      : TFNMediaInfoA_Count_Get;

  MediaInfo_Info_Version    : TFNMediaInfo_Info_Version;

  MediaInfo_New             : TFNMediaInfo_New;
  MediaInfo_New_Quick       : TFNMediaInfo_New_Quick;
  MediaInfo_Open            : TFNMediaInfo_Open;
  MediaInfo_Open_Buffer     : TFNMediaInfo_Open_Buffer;
  MediaInfo_Save            : TFNMediaInfo_Save;
  MediaInfo_Close           : TFNMediaInfo_Close;
  MediaInfo_Delete          : TFNMediaInfo_Delete;
  MediaInfo_Inform          : TFNMediaInfo_Inform;
  MediaInfo_GetI            : TFNMediaInfo_GetI;
  MediaInfo_Get             : TFNMediaInfo_Get;
  MediaInfo_SetI            : TFNMediaInfo_SetI;
  MediaInfo_Set             : TFNMediaInfo_Set;
  MediaInfo_Option          : TFNMediaInfo_Option;
  MediaInfo_State_Get       : TFNMediaInfo_State_Get;
  MediaInfo_Count_Get       : TFNMediaInfo_Count_Get;

  MediaInfoList_New         : TFNMediaInfoList_New;
  MediaInfoList_New_Quick   : TFNMediaInfoList_New_Quick;
  MediaInfoList_Delete      : TFNMediaInfoList_Delete;
  MediaInfoList_Open        : TFNMediaInfoList_Open;
  MediaInfoList_Open_Buffer : TFNMediaInfoList_Open_Buffer;
  MediaInfoList_Save        : TFNMediaInfoList_Save;
  MediaInfoList_Close       : TFNMediaInfoList_Close;
  MediaInfoList_Inform      : TFNMediaInfoList_Inform;
  MediaInfoList_GetI        : TFNMediaInfoList_GetI;
  MediaInfoList_Get         : TFNMediaInfoList_Get;
  MediaInfoList_SetI        : TFNMediaInfoList_SetI;
  MediaInfoList_Set         : TFNMediaInfoList_Set;
  MediaInfoList_Option      : TFNMediaInfoList_Option;
  MediaInfoList_Count_Get   : TFNMediaInfoList_Count_Get;

Function GetEntryPoints: boolean;

implementation

Function GetEntryPoints: boolean;
var
  lib:THandle;
begin
  @MediaInfoA_New            := NIL;
  @MediaInfoA_New_Quick      := NIL;
  @MediaInfoA_Open           := NIL;
  @MediaInfoA_Open_Buffer    := NIL;
  @MediaInfoA_Save           := NIL;
  @MediaInfoA_Close          := NIL;
  @MediaInfoA_Delete         := NIL;
  @MediaInfoA_Inform         := NIL;
  @MediaInfoA_GetI           := NIL;
  @MediaInfoA_Get            := NIL;
  @MediaInfoA_SetI           := NIL;
  @MediaInfoA_Set            := NIL;
  @MediaInfoA_Option         := NIL;
  @MediaInfoA_State_Get      := NIL;
  @MediaInfoA_Count_Get      := NIL;

  @MediaInfo_Info_Version    := NIL;

  @MediaInfo_New             := NIL;
  @MediaInfo_New_Quick       := NIL;
  @MediaInfo_Open            := NIL;
  @MediaInfo_Open_Buffer     := NIL;
  @MediaInfo_Save            := NIL;
  @MediaInfo_Close           := NIL;
  @MediaInfo_Delete          := NIL;
  @MediaInfo_Inform          := NIL;
  @MediaInfo_GetI            := NIL;
  @MediaInfo_Get             := NIL;
  @MediaInfo_SetI            := NIL;
  @MediaInfo_Set             := NIL;
  @MediaInfo_Option          := NIL;
  @MediaInfo_State_Get       := NIL;
  @MediaInfo_Count_Get       := NIL;

  @MediaInfoList_New         := NIL;
  @MediaInfoList_New_Quick   := NIL;
  @MediaInfoList_Delete      := NIL;
  @MediaInfoList_Open        := NIL;
  @MediaInfoList_Open_Buffer := NIL;
  @MediaInfoList_Save        := NIL;
  @MediaInfoList_Close       := NIL;
  @MediaInfoList_Inform      := NIL;
  @MediaInfoList_GetI        := NIL;
  @MediaInfoList_Get         := NIL;
  @MediaInfoList_SetI        := NIL;
  @MediaInfoList_Set         := NIL;
  @MediaInfoList_Option      := NIL;
  @MediaInfoList_Count_Get   := NIL;

  lib := LoadLibrary(@szNameDLL[1]);
  case lib = 0 of
    TRUE: Result := False;
    else
    begin
      Result := True;

      @MediaInfoA_New            := GetProcAddress(lib, @szNameMediaInfoA_New[1]);
      if not Assigned(MediaInfoA_New) then Result := False;

      @MediaInfoA_New_Quick      := GetProcAddress(lib, @szNameMediaInfoA_New_Quick[1]);
      if not Assigned(MediaInfoA_New_Quick) then Result := False;

      @MediaInfoA_Open           := GetProcAddress(lib, @szNameMediaInfoA_Open[1]);
      if not Assigned(MediaInfoA_Open) then Result := False;

      @MediaInfoA_Open_Buffer    := GetProcAddress(lib, @szNameMediaInfoA_Open_Buffer[1]);
      if not Assigned(MediaInfoA_Open_Buffer) then Result := False;

      @MediaInfoA_Save           := GetProcAddress(lib, @szNameMediaInfoA_Save[1]);
      if not Assigned(MediaInfoA_Save) then Result := False;

      @MediaInfoA_Close          := GetProcAddress(lib, @szNameMediaInfoA_Close[1]);
      if not Assigned(MediaInfoA_Close) then Result := False;

      @MediaInfoA_Delete         := GetProcAddress(lib, @szNameMediaInfoA_Delete[1]);
      if not Assigned(MediaInfoA_Delete) then Result := False;

      @MediaInfoA_Inform         := GetProcAddress(lib, @szNameMediaInfoA_Inform[1]);
      if not Assigned(MediaInfoA_Inform) then Result := False;

      @MediaInfoA_GetI           := GetProcAddress(lib, @szNameMediaInfoA_GetI[1]);
      if not Assigned(MediaInfoA_GetI) then Result := False;

      @MediaInfoA_Get            := GetProcAddress(lib, @szNameMediaInfoA_Get[1]);
      if not Assigned(MediaInfoA_Get) then Result := False;

      @MediaInfoA_SetI           := GetProcAddress(lib, @szNameMediaInfoA_SetI[1]);
      if not Assigned(MediaInfoA_SetI) then Result := False;

      @MediaInfoA_Set            := GetProcAddress(lib, @szNameMediaInfoA_Set[1]);
      if not Assigned(MediaInfoA_Set) then Result := False;

      @MediaInfoA_Option         := GetProcAddress(lib, @szNameMediaInfoA_Option[1]);
      if not Assigned(MediaInfoA_Option) then Result := False;

      @MediaInfoA_State_Get      := GetProcAddress(lib, @szNameMediaInfoA_State_Get[1]);
      if not Assigned(MediaInfoA_State_Get) then Result := False;

      @MediaInfoA_Count_Get      := GetProcAddress(lib, @szNameMediaInfoA_Count_Get[1]);
      if not Assigned(MediaInfoA_Count_Get) then Result := False;


      @MediaInfo_Info_Version    := GetProcAddress(lib, @szNameMediaInfo_Info_Version[1]);
      if not Assigned(MediaInfo_Info_Version) then Result := False;


      @MediaInfo_New             := GetProcAddress(lib, @szNameMediaInfo_New[1]);
      if not Assigned(MediaInfo_New) then Result := False;

      @MediaInfo_New_Quick       := GetProcAddress(lib, @szNameMediaInfo_New_Quick[1]);
      if not Assigned(MediaInfo_New) then Result := False;

      @MediaInfo_Open            := GetProcAddress(lib, @szNameMediaInfo_Open[1]);
      if not Assigned(MediaInfo_Open) then Result := False;

      @MediaInfo_Save            := GetProcAddress(lib, @szNameMediaInfo_Save[1]);
      if not Assigned(MediaInfo_Save) then Result := False;

      @MediaInfo_Close           := GetProcAddress(lib, @szNameMediaInfo_Close[1]);
      if not Assigned(MediaInfo_Close) then Result := False;

      @MediaInfo_Delete          := GetProcAddress(lib, @szNameMediaInfo_Delete[1]);
      if not Assigned(MediaInfo_Delete) then Result := False;

      @MediaInfo_Inform          := GetProcAddress(lib, @szNameMediaInfo_Inform[1]);
      if not Assigned(MediaInfo_Inform) then Result := False;

      @MediaInfo_GetI            := GetProcAddress(lib, @szNameMediaInfo_GetI[1]);
      if not Assigned(MediaInfo_GetI) then Result := False;

      @MediaInfo_Get             := GetProcAddress(lib, @szNameMediaInfo_Get[1]);
      if not Assigned(MediaInfo_Get) then Result := False;

      @MediaInfo_SetI            := GetProcAddress(lib, @szNameMediaInfo_SetI[1]);
      if not Assigned(MediaInfo_SetI) then Result := False;

      @MediaInfo_Set             := GetProcAddress(lib, @szNameMediaInfo_Set[1]);
      if not Assigned(MediaInfo_Set) then Result := False;

      @MediaInfo_Option          := GetProcAddress(lib, @szNameMediaInfo_Option[1]);
      if not Assigned(MediaInfo_Option) then Result := False;

      @MediaInfo_State_Get       := GetProcAddress(lib, @szNameMediaInfo_State_Get[1]);
      if not Assigned(MediaInfo_State_Get) then Result := False;

      @MediaInfo_Count_Get       := GetProcAddress(lib, @szNameMediaInfo_Count_Get[1]);
      if not Assigned(MediaInfo_Count_Get) then Result := False;


      @MediaInfoList_New         := GetProcAddress(lib, @szNameMediaInfoList_New[1]);
      if not Assigned(MediaInfoList_New) then Result := False;

      @MediaInfoList_New_Quick   := GetProcAddress(lib, @szNameMediaInfoList_New_Quick[1]);
      if not Assigned(MediaInfoList_New_Quick) then Result := False;

      @MediaInfoList_Delete      := GetProcAddress(lib, @szNameMediaInfoList_Delete[1]);
      if not Assigned(MediaInfoList_Delete) then Result := False;

      @MediaInfoList_Open        := GetProcAddress(lib, @szNameMediaInfoList_Open[1]);
      if not Assigned(MediaInfoList_Open) then Result := False;

      @MediaInfoList_Open_Buffer := GetProcAddress(lib, @szNameMediaInfoList_Open_Buffer[1]);
      if not Assigned(MediaInfoList_Open_Buffer) then Result := False;

      @MediaInfoList_Save        := GetProcAddress(lib, @szNameMediaInfoList_Save[1]);
      if not Assigned(MediaInfoList_Save) then Result := False;

      @MediaInfoList_Close       := GetProcAddress(lib, @szNameMediaInfoList_Close[1]);
      if not Assigned(MediaInfoList_Close) then Result := False;

      @MediaInfoList_Inform      := GetProcAddress(lib, @szNameMediaInfoList_Inform[1]);
      if not Assigned(MediaInfoList_Inform) then Result := False;

      @MediaInfoList_GetI        := GetProcAddress(lib, @szNameMediaInfoList_GetI[1]);
      if not Assigned(MediaInfoList_GetI) then Result := False;

      @MediaInfoList_Get         := GetProcAddress(lib, @szNameMediaInfoList_Get[1]);
      if not Assigned(MediaInfoList_Get) then Result := False;

      @MediaInfoList_SetI        := GetProcAddress(lib, @szNameMediaInfoList_SetI[1]);
      if not Assigned(MediaInfoList_SetI) then Result := False;

      @MediaInfoList_Set         := GetProcAddress(lib, @szNameMediaInfoList_Set[1]);
      if not Assigned(MediaInfoList_Set) then Result := False;

      @MediaInfoList_Option      := GetProcAddress(lib, @szNameMediaInfoList_Option[1]);
      if not Assigned(MediaInfoList_Option) then Result := False;

      @MediaInfoList_Count_Get   := GetProcAddress(lib, @szNameMediaInfoList_Count_Get[1]);
      if not Assigned(MediaInfoList_Count_Get) then Result := False;
    end;
  end;
end;

end.

